#include "chip.h"
#include <stdlib.h>

typedef struct {
    int id;
    __IO uint32_t *clk_reg;
    uint32_t clk_msk;
    __IO uint32_t *rst_reg;
    uint32_t rst_msk;
} t_per_regs;



static const t_per_regs f_per_regs[] = {
    /* AHB */
    {CHIP_PER_ID_DMA1,      &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_DMA1_EN,      NULL,                       0},
    {CHIP_PER_ID_DMA2,      &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_DMA2_EN,      NULL,                       0},
    {CHIP_PER_ID_SRAM,      &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_SRAM_EN,      NULL,                       0},
#ifdef CHIP_REGFLD_RCC_AHBENR_FLITF_EN
    {CHIP_PER_ID_FLASH,     &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_FLITF_EN,     NULL,                       0},
#endif
    {CHIP_PER_ID_CRC,       &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_CRC_EN,       NULL,                       0},
#if CHIP_DEV_SUPPORT_EXMC
    {CHIP_PER_ID_EXMC,      &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_EXMC_EN,      NULL,                       0},
#endif
#if CHIP_DEV_SUPPORT_RNG
    {CHIP_PER_ID_RNG,       &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_RNG_EN,       NULL,                       0},
#endif
#if CHIP_DEV_SDIO_CNT >= 1
    {CHIP_PER_ID_SDIO1,     &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_SDIO1_EN,     NULL,                       0},
#endif
#if CHIP_DEV_USBHS_CNT >= 1
    {CHIP_PER_ID_USBHS,     &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_USBHS_EN,     NULL,                       0},
#endif
#if defined CHIP_DEV_ST32F105_XC || defined CHIP_DEV_ST32F107_XC || defined CHIP_DEV_CH32XXXX
    {CHIP_PER_ID_USBHD,     &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_USBHD_EN,     &CHIP_REGS_RCC->AHBRSTR,    CHIP_REGFLD_RCC_AHBRSTR_USBHD_RST},
#else
    {CHIP_PER_ID_USBHD,     &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_USBHD_EN,     NULL,     0},
#endif
#if CHIP_DEV_DVP_CNT >= 1
    {CHIP_PER_ID_DVP,       &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_DVP_EN,       &CHIP_REGS_RCC->AHBRSTR,    CHIP_REGFLD_RCC_AHBRSTR_DVP_RST},
#endif
#if CHIP_DEV_ETH_CNT >= 1
    {CHIP_PER_ID_ETH_MAC,   &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_ETH_MAC_EN,   &CHIP_REGS_RCC->AHBRSTR,    0 /*CHIP_REGFLD_RCC_AHBRSTR_MAC_RST */},
    {CHIP_PER_ID_ETH_TX,    &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_ETH_MAC_TX_EN,NULL,                       0},
    {CHIP_PER_ID_ETH_RX,    &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_ETH_MAC_RX_EN,NULL,                       0},
#endif
#if CHIP_DEV_BLES_CNT >= 1
    {CHIP_PER_ID_BLES,      &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_BLES,         NULL,                       0},
#endif
    /* APB2 */
    {CHIP_PER_ID_AFIO,      &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_AFIO_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_AFIO_RST},
    {CHIP_PER_ID_GPIOA,     &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_IOPA_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_IOPA_RST},
    {CHIP_PER_ID_GPIOB,     &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_IOPB_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_IOPB_RST},
    {CHIP_PER_ID_GPIOC,     &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_IOPC_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_IOPC_RST},
    {CHIP_PER_ID_GPIOD,     &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_IOPD_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_IOPD_RST},
    {CHIP_PER_ID_GPIOE,     &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_IOPE_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_IOPE_RST},
    {CHIP_PER_ID_GPIOF,     &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_IOPF_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_IOPF_RST},
    {CHIP_PER_ID_GPIOG,     &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_IOPG_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_IOPG_RST},
    {CHIP_PER_ID_ADC1,      &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_ADC1_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_ADC1_RST},
#if CHIP_DEV_ADC_CNT >= 2
    {CHIP_PER_ID_ADC2,      &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_ADC2_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_ADC2_RST},
#endif
    {CHIP_PER_ID_TIM1,      &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_TIM1_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_TIM1_RST},
    {CHIP_PER_ID_SPI1,      &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_SPI1_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_SPI1_RST},
    {CHIP_PER_ID_TIM8,      &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_TIM8_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_TIM8_RST},
    {CHIP_PER_ID_USART1,    &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_USART1_EN,   &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_USART1_RST},
#if CHIP_DEV_ADC_CNT >=3
    {CHIP_PER_ID_ADC3,      &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_ADC3_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_ADC3_RST},
#endif
#if CHIP_DEV_SUPPORT_TIM9
    {CHIP_PER_ID_TIM9,      &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_TIM9_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_TIM9_RST},
#endif
#if CHIP_DEV_SUPPORT_TIM10
    {CHIP_PER_ID_TIM10,     &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_TIM10_EN,    &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_TIM10_RST},
#endif
#if CHIP_DEV_SUPPORT_TIM11
    {CHIP_PER_ID_TIM11,     &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_TIM11_EN,    &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_TIM11_RST},
#endif
    /* APB1 */
    {CHIP_PER_ID_TIM2,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_TIM2_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_TIM2_RST},
    {CHIP_PER_ID_TIM3,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_TIM3_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_TIM3_RST},
    {CHIP_PER_ID_TIM4,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_TIM4_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_TIM4_RST},
    {CHIP_PER_ID_TIM5,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_TIM5_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_TIM5_RST},
    {CHIP_PER_ID_TIM6,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_TIM6_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_TIM6_RST},
    {CHIP_PER_ID_TIM7,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_TIM7_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_TIM7_RST},
#ifdef CHIP_DEV_CH32XXXX
#if CHIP_DEV_UART_CNT >= 6
    {CHIP_PER_ID_UART6,     &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_UART6_EN,    &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_UART6_RST},
#endif
#if CHIP_DEV_UART_CNT >= 7
    {CHIP_PER_ID_UART7,     &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_UART7_EN,    &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_UART7_RST},
#endif
#if CHIP_DEV_UART_CNT >= 8
    {CHIP_PER_ID_UART8,     &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_UART8_EN,    &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_UART8_RST},
#endif
#endif
#if CHIP_DEV_SUPPORT_TIM12
    {CHIP_PER_ID_TIM12,     &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_TIM12_EN,    &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_TIM12_RST},
#endif
#if CHIP_DEV_SUPPORT_TIM13
    {CHIP_PER_ID_TIM13,     &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_TIM13_EN,    &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_TIM13_RST},
#endif
#if CHIP_DEV_SUPPORT_TIM14
    {CHIP_PER_ID_TIM14,     &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_TIM13_EN,    &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_TIM14_RST},
#endif
    {CHIP_PER_ID_WWDG,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_WWDG_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_WWDG_RST},
    {CHIP_PER_ID_SPI2,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_SPI2_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_SPI2_RST},
#if CHIP_DEV_SPI_CNT >= 3
    {CHIP_PER_ID_SPI3,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_SPI3_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_SPI3_RST},
#endif
    {CHIP_PER_ID_USART2,    &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_USART2_EN,   &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_USART2_RST},
    {CHIP_PER_ID_USART3,    &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_USART3_EN,   &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_USART3_RST},
#if CHIP_DEV_UART_CNT >= 4
    {CHIP_PER_ID_UART4,     &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_UART4_EN,    &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_UART4_RST},
#endif
#if CHIP_DEV_UART_CNT >= 5
    {CHIP_PER_ID_UART5,     &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_UART5_EN,    &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_UART5_RST},
#endif
    {CHIP_PER_ID_I2C1,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_I2C1_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_I2C1_RST},
    {CHIP_PER_ID_I2C2,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_I2C2_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_I2C2_RST},
    {CHIP_PER_ID_USBD,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_USBD_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_USBD_RST},
#if CHIP_DEV_CAN_CNT >= 1
    {CHIP_PER_ID_CAN1,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_CAN1_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_CAN1_RST},
#endif
#if CHIP_DEV_CAN_CNT >= 2
    {CHIP_PER_ID_CAN2,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_CAN2_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_CAN2_RST},
#endif
    {CHIP_PER_ID_BKP,       &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_BKP_EN,      &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_BKP_RST},
    {CHIP_PER_ID_PWR,       &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_PWR_EN,      &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_PWR_RST},
    {CHIP_PER_ID_DAC,       &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_DAC_EN,      &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_DAC_RST},
};

static const t_per_regs *get_per_regs(int id) {
    const t_per_regs *ret = 0;
    for (unsigned i = 0; i < sizeof(f_per_regs)/sizeof(f_per_regs[0]); i++) {
        if (f_per_regs[i].id == id) {
            ret = &f_per_regs[i];
            break;
        }
    }
    return ret;
}

void chip_per_rst(int per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    if (reg && reg->rst_reg) {
        *reg->rst_reg |= reg->rst_msk;
        chip_dmb();
        *reg->rst_reg &= ~reg->rst_msk;
        chip_dsb();
    }
}

void chip_per_clk_en(int per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    if (reg && reg->clk_reg) {
        *reg->clk_reg |= reg->clk_msk;
    }
}

void chip_per_clk_dis(int per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    if (reg && reg->clk_reg) {
        *reg->clk_reg &= ~reg->clk_msk;
    }
}

bool chip_per_clk_is_en(int per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    return  reg && reg->clk_reg && ((*reg->clk_reg & reg->clk_msk) != 0);
}
